/**********************************************************************

 * File:	Find_Prob_SQL.sql
 * Type:	SQL*Plus script
 * Author:	Ptur Thr Grtarsson
 * Date:	Mar 19, 2010
 *
 * Description:
 *	This script finds problem sql based on both 3000 disk reads and/or 40000 logical reads.
 *
 *
 * Modifications:

 *********************************************************************/



set echo off
set serveroutput on size 999999
set line 32767
set scan on
set trimspool on
set verify off
set feedback off
col SQL format a150

-- *********************************************************************************************************************************************************************
--prompt
--accept TEMP_PATH char prompt 'Please enter temp path (w/o last backslash, default is C:\TEMP)   : ' default C:\TEMP
--prompt
-- *********************************************************************************************************************************************************************


/* 
Bad SQL identifying statements using on average, more than 3,000 disk reads
 (10 seconds'worth) per execution.
*/ 

spool Find_prob_SQL.txt

select   hash_value,
         executions                                       as "Executions",
         disk_reads / decode(executions,0,1,
                                        executions) / 300 as "Expected time in sec",
         sql_text as "SQL"
from     sys.v_$sql
where    disk_reads / decode(executions,0,1,
                                        executions) / 300 > 10
         and executions > 0
--         and module in ('IFaceExecutor.exe','aspnet_wp.exe','dllhost.exe','w3wp.exe',
--                        'BasWareIPMonitor.exe','BasWareIPAdmin.exe','BasWareIPAgent.exe','BaswareIPProClient.exe',
--                        'BasWareIPMaster.exe')
order by disk_reads
/ 
spool off

/*
If you want to retrive the whole sql statement the you can run the following query :
	select   sql_text
	from     v$sqltext
	where    hash_value = '<hash_value here>'
	order by piece; 
*/


/*
Identifying bad SQL that result in getting more than 40,000 buffer gets.
*/

SELECT   hash_value "Hash value", 
         executions "Executions",
         buffer_gets / DECODE(executions,0,1,
                                           executions) / 4000 "Expected time in sec",
         sql_text as "SQL"
FROM     sys.v_$sql
WHERE    buffer_gets / DECODE(executions,0,1,
                                         executions) / 4000 > 10
         AND executions > 0
--         and module in ('IFaceExecutor.exe','aspnet_wp.exe','dllhost.exe','w3wp.exe',
--                        'BasWareIPMonitor.exe','BasWareIPAdmin.exe','BasWareIPAgent.exe','BaswareIPProClient.exe',
--                        'BasWareIPMaster.exe')
ORDER BY buffer_gets
/ 

spool off

/*
If you want to retrive the whole sql statement the you can run the following query :
	select   sql_text
	from     v$sqltext
	where    hash_value = '<hash_value here>'
	order by piece; 
*/