rem   
rem   Dan Hotka 
rem   Show_v$Plan.sql   - used to print contents from V$SQL_Table
rem
rem   Install utlxplan.sql for each user, then put this line in front of sql statement
rem   --> explain plan  for <SQL statement>
rem   -->  run this script --> sqlplus userid/pwd @show_v$plan <some name>
rem
SET TERMOUT OFF
CLEAR SCREEN 
SET FEEDBACK OFF
SET VERIFY OFF
SET ECHO OFF
SET PAGESIZE 40
SET LINESIZE 100

SET TERMOUT ON

ACCEPT in_user PROMPT 'Enter User ID (upper case)  : '

column program format a20

select substr(sql_text,1,50) "SQL TEXT", hash_value "SQL VALUE", 
substr(module,1,10) "PROGRAM", elapsed_time / 1000000 "ELAPSED TIME"
from v$SQL
where '&in_user' = parsing_schema_name;
 
ACCEPT in_addr PROMPT 'Enter SQL VALUE from list above : '

SET TERMOUT OFF

column id format 999 heading 'ID'
column parent_id format 999 heading 'P_ID'
column cost format 999 heading 'Cost'
column cardinality format 9999999 heading 'Rows'
column access_plan format a30 heading 'Access|Plan'
column access_path format a15 heading 'Access|Path'
column object_name format a15 heading 'Object|Name'
column where_clause format a90 heading 'Where|Clause'

delete from plan_table;

insert into plan_table (cost,cardinality,id,parent_id,operation,options,object_name,access_predicates,filter_predicates)
select cost,cardinality,id, parent_id, operation, options,object_name,access_predicates,filter_predicates 
from v$sql_plan
where hash_value = &in_addr;

SET TERMOUT ON

select cost,cardinality, id, parent_id, lpad (' ', 2 * level) || operation Access_Plan, options Access_Path,
object_name, substr(access_predicates || ' ' || filter_predicates,1,90) WHERE_CLAUSE
from plan_table
connect by prior id = parent_id
start with id = 0; 




