SET DEF ON ECHO ON TERM ON LIN 2000 TRIMS ON SERVEROUT ON SIZE 1000000 TIM OFF SQLP SQL>;
SPO sqlt_s5655_ORA11R1_DANXP_metadata.log;
REM
REM $Header: 215187.1 sqlt_s5655_ORA11R1_DANXP_metadata.sql 11.2.9.8 2009/09/22 csierra $
REM
REM Copyright (c) 2000-2009, Oracle Corporation. All rights reserved.
REM
REM SCRIPT
REM   sqlt_s5655_ORA11R1_DANXP_metadata.sql
REM
REM DESCRIPTION
REM   This script is generated by the SQLT,
REM   and it contains the commands to create a test case user
REM   and its set of objects referenced by the SQL statement
REM   analyzed by the SQLT.
REM
REM PARAMETERS
REM   None.
REM
REM EXAMPLE
REM   SQL> start sqlt_s5655_ORA11R1_DANXP_metadata.sql;
REM
REM NOTES
REM   1. Review and edit "Customization" section below.
REM   2. Should be run as SYSTEM or SYSDBA.
REM

/*************************************************************************************/
--  Customization - Begin
/*************************************************************************************/

-- Restore System Statistics
EXEC DBMS_STATS.DELETE_SYSTEM_STATS;
EXEC DBMS_STATS.SET_SYSTEM_STATS('CPUSPEEDNW', 1845.90945194599);
EXEC DBMS_STATS.SET_SYSTEM_STATS('IOSEEKTIM', 10);
EXEC DBMS_STATS.SET_SYSTEM_STATS('IOTFRSPEED', 4096);

-- Create "test case user"
DEF TC_USER = TC5655;
GRANT DBA TO &&TC_USER. IDENTIFIED BY &&TC_USER.;

-- Use DEF command(s) below if you want to consolidate objects into one test case user TC5655. (recommended).
DEF SCHEMA_USER0                          = &&TC_USER.;

-- Un-comment DEF command(s) below ONLY if you want to create objects into original owner(s). (not recommended).
-- DEF SCHEMA_USER0                          = USER0;

/*************************************************************************************/
--  Customization - End
/*************************************************************************************/

SET TERM OFF;

-- staging table used for objects status report
CREATE TABLE sqlt$_metadata_objects (
  statement_id               INTEGER            NOT NULL,
  enumerator                 INTEGER            NOT NULL,
  object_type                VARCHAR2(32 CHAR)  NOT NULL,
  owner                      VARCHAR2(30 CHAR)  NOT NULL,
  object_name                VARCHAR2(128 CHAR) NOT NULL
);

-- taking care of subsequent executions of metadata script
DELETE sqlt$_metadata_objects WHERE statement_id = 5655;

/*************************************************************************************/

-- CBO statistics table
BEGIN
  DBMS_STATS.CREATE_STAT_TABLE (
    ownname  => '&&TC_USER.',
    stattab  => 'CBO_STAT_TAB_4TC' );
END;
/
GRANT ALL ON &&TC_USER..CBO_STAT_TAB_4TC TO SQLTXPLAIN;

/*************************************************************************************/


  INSERT INTO sqlt$_metadata_objects VALUES (5655, 1, 'TABLE', '&&SCHEMA_USER0', 'MANAGERS');

  CREATE TABLE "&&SCHEMA_USER0."."MANAGERS"
   (	"RECNUM" NUMBER NOT NULL ENABLE,
	"LAHMANID" VARCHAR2(12) NOT NULL ENABLE,
	"DATE_YYYY" NUMBER,
	"SEASON_HALF_ID" VARCHAR2(1),
	"TEAM_ID" VARCHAR2(3),
	"LEAGUE_ID" VARCHAR2(2),
	"DIVISION_ID" VARCHAR2(1),
	"GAME_QTY" NUMBER,
	"WIN_QTY" NUMBER,
	"LOSS_QTY" NUMBER,
	"WIN_PCT" NUMBER(5,2),
	"PLACE_FINISHED_NR" NUMBER,
	"ORDER_MANAGED_ID" VARCHAR2(10),
	"PLAY_MANAGE_Y_N" VARCHAR2(1)
   ) PCTFREE 5 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING;


/*************************************************************************************/

  INSERT INTO sqlt$_metadata_objects VALUES (5655, 2, 'TABLE', '&&SCHEMA_USER0', 'MASTER');

  CREATE TABLE "&&SCHEMA_USER0."."MASTER"
   (	"LAHMANID" VARCHAR2(12) NOT NULL ENABLE,
	"LAST_NAME_TX" VARCHAR2(25),
	"FIRST_NAME_TX" VARCHAR2(20),
	"BATS_RIGHT_LEFT_ID" VARCHAR2(1),
	"THROWS_RT_LEFT_ID" VARCHAR2(1),
	"BIRTH_DATE_MM" NUMBER,
	"BIRTH_DATE_DD" NUMBER,
	"BIRTH_DATE_YYYY" NUMBER,
	"DEBUT_SEASON_YYYY" NUMBER
   ) PCTFREE 5 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING;


/*************************************************************************************/

  INSERT INTO sqlt$_metadata_objects VALUES (5655, 3, 'TABLE', '&&SCHEMA_USER0', 'TEAMS');

  CREATE TABLE "&&SCHEMA_USER0."."TEAMS"
   (	"RECNUM" NUMBER NOT NULL ENABLE,
	"DATE_YYYY" NUMBER DEFAULT 0 NOT NULL ENABLE,
	"LEAGUE_ID" VARCHAR2(2) NOT NULL ENABLE,
	"POSITION_PLAYED_ID" NUMBER,
	"TEAM_ID" VARCHAR2(3) NOT NULL ENABLE,
	"GAME_PLAYED_QTY" NUMBER,
	"WIN_QTY" NUMBER,
	"LOSS_QTY" NUMBER,
	"WIN_PCT" NUMBER(5,2),
	"GAMES_BEHIND_QTY" NUMBER,
	"RUN_QTY" NUMBER,
	"OPPONENT_RUN_QTY" NUMBER,
	"AT_BAT_QTY" NUMBER,
	"HIT_QTY" NUMBER,
	"DOUBLE_QTY" NUMBER,
	"TRIPLE_QTY" NUMBER,
	"HOME_RUN_QTY" NUMBER,
	"WALK_QTY" NUMBER,
	"STRIKE_OUT_QTY" NUMBER,
	"BATTING_AVG" NUMBER(4,3),
	"ON_BASE_PCT" NUMBER(4,3),
	"SLUGGING_PCT" NUMBER(4,3),
	"STOLEN_BASE_QTY" NUMBER,
	"CAUGHT_STEALING_QY" NUMBER,
	"EARNED_RUN_AVG" NUMBER(4,2),
	"COMPLETE_GAME_QTY" NUMBER,
	"SHUTOUT_QTY" NUMBER,
	"SAVE_QTY" NUMBER,
	"INNING_PITCHED_QTY" NUMBER(6,2),
	"HIT_BY_OPP_QTY" NUMBER,
	"HOME_RUN_BY_OPP_QY" NUMBER,
	"WALK_BY_OPP_QTY" NUMBER,
	"STRIKE_OUT_OPP_QTY" NUMBER,
	"PARK_BAT_FACTOR" NUMBER,
	"PARK_PITCH_FACTOR" NUMBER,
	"BALLPARK_NAME" VARCHAR2(200),
	"ATTENDENCE_QTY" NUMBER
   ) PCTFREE 5 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING;


  INSERT INTO sqlt$_metadata_objects VALUES (5655, 4, 'INDEX', '&&SCHEMA_USER0', 'TEAMS_PK');

  CREATE UNIQUE INDEX "&&SCHEMA_USER0."."TEAMS_PK" ON "&&SCHEMA_USER0."."TEAMS" ("DATE_YYYY",
	"LEAGUE_ID",
	"TEAM_ID")
  PCTFREE 5 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS ;


/*************************************************************************************/

/*************************************************************************************/
--  ALTER TABLE: Iteration #1
/*************************************************************************************/

/*************************************************************************************/
--  ALTER TABLE: Iteration #2
/*************************************************************************************/

/*************************************************************************************/
--  ALTER TABLE: Iteration #3
/*************************************************************************************/
--  Objects Status
/*************************************************************************************/

SET TERM ON ECHO OFF;
DECLARE
  my_status VARCHAR2(12);
BEGIN
  DBMS_OUTPUT.PUT_LINE('/* ----------------------- */');
  DBMS_OUTPUT.PUT_LINE('-- Objects Status');
  DBMS_OUTPUT.PUT_LINE('/* ----------------------- */');
  FOR i IN (SELECT * FROM sqlt$_metadata_objects WHERE statement_id = 5655 ORDER BY enumerator)
  LOOP
    BEGIN
      SELECT status INTO my_status FROM dba_objects
      WHERE object_type = i.object_type AND owner = i.owner AND object_name = i.object_name AND ROWNUM = 1;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        my_status := 'NOT CREATED';
    END;
    DBMS_OUTPUT.PUT_LINE(
      RPAD(SUBSTR(i.object_type, 1, 14), 15)||
      RPAD(SUBSTR(i.owner||'.'||i.object_name, 1, 44), 45)||
      LPAD(TO_CHAR(i.enumerator), 5)||'  '||
      my_status);
  END LOOP;
END;
/
DROP TABLE sqlt$_metadata_objects;
SET ECHO ON;
SPO OFF;
