SET ECHO ON TERM ON LIN 2000 TRIMS ON SERVEROUT ON SIZE 1000000 TIM OFF SQLP SQL>;
SPO sqlt_s5656_ORA11R1_DANXP_tc_builder.log;
REM
REM $Header: 215187.1 sqlt_s5656_ORA11R1_DANXP_tc_builder.sql 11.2.9.8 2009/09/22 csierra $
REM
REM Copyright (c) 2000-2009, Oracle Corporation. All rights reserved.
REM
REM SCRIPT
REM   sqlt_s5656_ORA11R1_DANXP_tc_builder.sql
REM
REM DESCRIPTION
REM   This script is generated and executed by the SQLT tool. It contains the
REM   commands to export a test case from your system.
REM
REM   To later import the Test Case created by this script you can use one of
REM   the two options below.
REM
REM     -- Use this option when SQLT is installed in target system.
REM     -- 1. Unzip first sqlt_s5656_tc.zip into UDUMP, and import table below.
REM     -- 2. # imp sqltxplain tables='sqlt$_hist_files' file=sqlt_s5656.dmp ignore=y
REM     -- 3. GRANT DBA TO TCUSER IDENTIFIED BY TCUSER;
REM     -- 4. Execute PL/SQL block connected as TCUSER:
REM     -- Note: TCUSER must be granted DBA or (ADMINISTER SQL MANAGEMENT OBJECT and READ/WRITE on SQLT$UDUMP)
REM     BEGIN
REM       DBMS_SQLDIAG.IMPORT_SQL_TESTCASE (
REM         directory         => 'SQLT$UDUMP',
REM         sqlTestCase       => sqltxplain.sqlt$r.get_file('sqlt_s5656_tc_main.xml'),
REM         importEnvironment => TRUE,
REM         importMetadata    => TRUE,
REM         importData        => FALSE, -- No Data was exported!
REM         importPkgbody     => TRUE,
REM         importDiagnosis   => TRUE,
REM         ignoreStorage     => TRUE,
REM         ctrlOptions       => NULL );
REM     END;
REM     /
REM
REM     -- Use this option to import test case without using SQLT in target system.
REM     -- 1. CREATE DIRECTORY TC_DIR AS '<valid server directory path>'; (create also OS matching directory)
REM     -- 2. Unzip sqlt_s5656_tc.zip into previously created TC_DIR.
REM     -- 3. GRANT DBA TO TCUSER IDENTIFIED BY TCUSER;
REM     -- 4. Execute PL/SQL block connected as TCUSER:
REM     -- Note: TCUSER must be granted DBA or (ADMINISTER SQL MANAGEMENT OBJECT and READ/WRITE on TC_DIR)
REM     BEGIN
REM       DBMS_SQLDIAG.IMPORT_SQL_TESTCASE (
REM         directory         => 'TC_DIR',
REM         filename          => 'sqlt_s5656_tc_main.xml',
REM         importEnvironment => TRUE,
REM         importMetadata    => TRUE,
REM         importData        => FALSE, -- No Data wss exported!
REM         importPkgbody     => TRUE,
REM         importDiagnosis   => TRUE,
REM         ignoreStorage     => TRUE,
REM         ctrlOptions       => NULL );
REM     END;
REM     /
REM
REM PARAMETERS
REM   None.
REM
REM EXAMPLE
REM   SQL> start sqlt_s5656_ORA11R1_DANXP_tc_builder.sql;
REM
REM NOTES
REM   1. Review and edit before execution.
REM   2. To execute this script connect as the application user or SYSTEM
REM      or another user with DBA privilege.
REM   3. User must have DBA privilege or these grants below:
REM        ADMINISTER SQL MANAGEMENT OBJECT
REM        READ  ON DIRECTORY SQLT$STAGE
REM        WRITE ON DIRECTORY SQLT$STAGE
REM        READ  ON DIRECTORY SQLT$UDUMP
REM        WRITE ON DIRECTORY SQLT$UDUMP
REM   4. Application user can be given grants above using sqlt/install/sqguser.sql
REM
SET ECHO OFF;
PRO
PRO ... Exporting Test Case sqlt_s5656_tc_* into Server Directory
PRO ... c:\oracle\diag\rdbms\ora11r1\ora11r1\trace
PRO
SET ECHO ON;

DECLARE
  testcase_clob CLOB;
BEGIN
  DBMS_SQLDIAG.EXPORT_SQL_TESTCASE (
    directory         => 'SQLT$STAGE', -- c:\oracle\diag\rdbms\ora11r1\ora11r1\trace
    sql_id            => 'gtyp03pnqwkt1',
    plan_hash_value   => 2196188739,
    exportEnvironment => TRUE,
    exportMetadata    => TRUE,
    exportData        => FALSE, -- No Data is exported!
    exportPkgbody     => TRUE,
    samplingPercent   => 100,
    ctrlOptions       => NULL,
    timeLimit         => 1800,
    testcase_name     => 'sqlt_s5656_tc_',
    testcase          => testcase_clob );

  sqltxplain.sqlt$r.set_file (
    p_file_type    => 'TC_MAIN',
    p_filename     => 'sqlt_s5656_tc_main.xml',
    p_file_text    => testcase_clob,
    p_statement_id => 5656,
    p_statid       => 's5656_ORA11R1_DANXP' );
END;
/

SET ECHO OFF;
PRO
PRO ... generating now a zip with all test case files
PRO
PRO ... if sqlt_s5656_tc.zip is not created, please execute manually:
PRO ... # zip -jmT sqlt_s5656_tc c:\oracle\diag\rdbms\ora11r1\ora11r1\trace/sqlt_s5656_tc_*
PRO ... # zip -jmT sqlt_s5656_tc c:\oracle\diag\rdbms\ora11r1\ora11r1\trace/README.txt
PRO ... # zip -mT sqlt_s5656_tc sqlt_s5656_ORA11R1_DANXP_tc_builder.log
PRO ... # zip -T sqlt_s5656_tc sqlt_s5656_ORA11R1_DANXP_tc_builder.sql
PRO
SPO OFF;
HO zip -jmT sqlt_s5656_tc c:\oracle\diag\rdbms\ora11r1\ora11r1\trace/sqlt_s5656_tc_*
HO zip -jmT sqlt_s5656_tc c:\oracle\diag\rdbms\ora11r1\ora11r1\trace/README.txt
HO zip -mT sqlt_s5656_tc sqlt_s5656_ORA11R1_DANXP_tc_builder.log
HO zip -T sqlt_s5656_tc sqlt_s5656_ORA11R1_DANXP_tc_builder.sql
PRO SQLT_TC_BUILDER completed.
